//-----------------------------------------------------------------------------
//
//	Musepack Decoder
//
//	Author : Igor Janos
//
//-----------------------------------------------------------------------------
#pragma once

#define CMD_EXIT		0
#define CMD_STOP		1
#define CMD_RUN			2


//-----------------------------------------------------------------------------
//
//	CMPCDecoder class
//
//-----------------------------------------------------------------------------
class CMPCDecoder : 
	public CTransformFilter,
	public ISpecifyPropertyPages
{
public:

	CCritSec			lock_filter;
	WAVEFORMATEX		wfOut;

public:
	// constructor
	CMPCDecoder(LPUNKNOWN pUnk, HRESULT *phr);
	virtual ~CMPCDecoder();
	static CUnknown * WINAPI CreateInstance(LPUNKNOWN pUnk, HRESULT *phr);

	// override this to publicise our interfaces
	DECLARE_IUNKNOWN;
	STDMETHODIMP NonDelegatingQueryInterface(REFIID riid, void **ppv);

    // ISpecifyPropertyPages interface
    STDMETHODIMP GetPages(CAUUID *pPages);

	// Pure virtual methods
	virtual HRESULT CheckInputType(const CMediaType *mtIn);
	virtual HRESULT CheckTransform(const CMediaType *mtIn, const CMediaType *mtOut);
	virtual HRESULT DecideBufferSize(IMemAllocator *pAlloc, ALLOCATOR_PROPERTIES *pProp);
	virtual HRESULT GetMediaType(int iPosition, CMediaType *pmt);
	virtual HRESULT SetMediaType(PIN_DIRECTION direction, const CMediaType *pmt);
	virtual HRESULT BreakConnect(PIN_DIRECTION dir);

	// activate/deactivate decoder
	virtual HRESULT StartStreaming();
	virtual HRESULT StopStreaming();

	// decoding input packets
	virtual HRESULT Receive(IMediaSample *pSample);
	//HRESULT DeliverSamples(int16 *input, int time_count);
	virtual HRESULT GetDeliveryBuffer(IMediaSample **sample);

};


